/* simple control program for philips tv1000 tv card */

#include "sys_head.h"

FILE * exec_filefd;
char home_dir[512];

extern int tv1000_volume;
extern int tv1000_bass;
extern int tv1000_treble;
extern int tv1000_saturation;
extern int tv1000_brightness;
extern int tv1000_contrast;
extern int tv1000_channel;
extern int tv1000_mute;
extern int tv1000_external;
extern int tv1000_external_direct;
extern int tv1000_fine_tune;


helppri()/*print help menu*/
{
FILE *helpfile;
int a, c, lines;
char path_filename[512];

sprintf(path_filename, "%s/.tv1000/%s", home_dir, "tvhelp.asc");
helpfile = fopen(path_filename, "r");
if(! helpfile)
	{
	fprintf(stdout, "\nCannot open file %s", path_filename);
	return(0);
	}
lines = 0;
while(1)
	{
	c = getc(helpfile);
	if(c == EOF) break;
	fprintf(stdout, "%c", c);
	if(c == '\n') lines++;
	if(lines == 22)
		{
		lines = 0;
		fprintf(stdout, "\nEnter for more \n");
		/* read a user key */	
		system("stty raw");
		c = getc(stdin);
		system("stty sane");
		if(c == 27)break;/* ESCAPE exits */
		fprintf(stdout, "\n");
		}
	}
fclose(helpfile);
return(1);
}


main()
{
int c;
char temp[512];
int audio_volume;
struct passwd *userinfo;

/*defaults set here*/
audio_volume = 80;

/*end defaults setting*/

fprintf(stdout, "\nPanteltje (c)  TV1000 control program  v. 0.1  1996\n\n");
fprintf(stdout, "\ntype h for help\n");

/* get user info */
userinfo = getpwuid(getuid() );

/* get home directory */
sprintf(home_dir, "%s", userinfo -> pw_dir);

tv1000_ini();
while(1)
	{
	/* read a user key */	
	system("stty raw");
	c = getc(stdin);
	system("stty sane");
	switch(c)
		{
		case 'h':
			helppri();
			break;
		case 'q':
		case 27: /* ESCAPE exits */
			break;
		case '1': /* select computer */
			tv1000_set_screen(0);
			break;
		case '2': /* select tv program */
			tv1000_set_screen(1);
			break;
		case 'v':
		case '4': /* internal volume dtv1000 down */
			if(tv1000_volume > 0) tv1000_volume--;
			tv1000_set_volume(tv1000_volume, 3);/* left + right */
			break;			
		case 'V':
		case '5': /* internal volume dtv1000 down */
			if(tv1000_volume < 31) tv1000_volume++;
			tv1000_set_volume(tv1000_volume, 3);/* left + right */
			break;			
		case '-':/* volume down */
			if(audio_volume > 0) audio_volume--;
			sprintf(temp, "cmix vol %d", audio_volume);
			exec_filefd = popen(temp, "r");
			pclose(exec_filefd);
			if(! exec_filefd) break;
			break;
		case '+':/* volume up */
			if(audio_volume < 100) audio_volume++;
			sprintf(temp, "cmix vol %d", audio_volume);
			exec_filefd = popen(temp, "r");
			if(! exec_filefd) break;
			pclose(exec_filefd);
			break;	
		case '`':/* audio mute toggle */
			tv1000_mute ^= 1;
			tv1000_set_mute(tv1000_mute);			
			break;
		case 'b':/* bass down */
			if(tv1000_bass > 0) tv1000_bass--;
			tv1000_set_bass(tv1000_bass);
			break;
		case 'B':/* bass up */
			if(tv1000_bass < 15) tv1000_bass++;
			tv1000_set_bass(tv1000_bass);
			break;
		case 't':/* treble down */
			if(tv1000_treble > 0) tv1000_treble--;
			tv1000_set_treble(tv1000_treble);
			break;
		case 'T':/* treble up */
			if(tv1000_treble < 15) tv1000_treble++;
			tv1000_set_treble(tv1000_treble);
			break;
		case 's':/* saturation down */
			if(tv1000_saturation > 0) tv1000_saturation--;
			tv1000_set_saturation(tv1000_saturation);
			break;
		case 'S':/* saturation up */
			if(tv1000_saturation < 63) tv1000_saturation++;
			tv1000_set_saturation(tv1000_saturation);
			break;
		case 'l':/* brightness down */
			if(tv1000_brightness > 0) tv1000_brightness--;
			tv1000_set_brightness(tv1000_brightness);
			break;
		case 'L':/* brightness up */
			if(tv1000_brightness < 63) tv1000_brightness++;
			tv1000_set_brightness(tv1000_brightness);
			break;
		case 'c':/* contrast down */
			if(tv1000_contrast > 0) tv1000_contrast--;
			tv1000_set_contrast(tv1000_contrast);
			break;
		case 'C':/* contrast up */
			if(tv1000_contrast < 63) tv1000_contrast++;
			tv1000_set_contrast(tv1000_contrast);
			break;
		case 'P':/* preset vt1000 saturation, brightness, contrast,
				/* bass, treble, volume */
			tv1000_ini();
			break;
		case 'f':/* load preferences from file */
			fprintf(stdout, "\nLOAD preferences filename? ");
			fscanf(stdin, "%s", temp);
			if( tv1000_load_preferences_from_file(temp) )
				{
				fprintf(stdout, "\npreferences loaded");
				}
			else/* error report in tv1000_load_preferences */
				{
				}
			break;
		case 'F':/* save preferences to file */
			fprintf(stdout, "\nSAVE preferences as? ");
			fscanf(stdin, "%s", temp);
			if( tv1000_save_preferences_to_file(temp) )
				{
				fprintf(stdout, "\npreferences saved");
				}
			else/* error report in tv1000_save_preferences */
				{
				}
			break;
		case 'i':/* internal (TV)*/
			tv1000_external = 0;
			tv1000_set_input(tv1000_external);
			break;
		case 'e':/* external (VCR)*/
			tv1000_external = 1;
			tv1000_set_input(tv1000_external);
			break;
		case 'd':/* channel down */
			if(tv1000_channel > 0) tv1000_channel--; 
			tv1000_set_channel(tv1000_channel);
			break;
		case 'D':/* channel up */
			if(tv1000_channel < 63) tv1000_channel++;
			tv1000_set_channel(tv1000_channel);
			break;	 	
		case '~':/*shifted ''', channel 0 */
			tv1000_channel = 0;
			tv1000_set_channel(tv1000_channel);	
			break;
		case '!':/* shifted 1, channel 1 */
			tv1000_channel = 1;
			tv1000_set_channel(tv1000_channel);
			break;
		case '@': /* shifted 2, channel 2 */
			tv1000_channel = 2;
			tv1000_set_channel(tv1000_channel);
			break;
		case '#':/* shifted 3, channel 3 */
			tv1000_channel = 3;
			tv1000_set_channel(tv1000_channel);
			break;
		case '$':/* shifted 4, channel 4 */
			tv1000_channel = 4;
			tv1000_set_channel(tv1000_channel);
			break;
		case '%':/* shifted 5, channel 5 */
			tv1000_channel = 5;
			tv1000_set_channel(tv1000_channel);
			break;
		case '^':
			tv1000_channel = 6;
			tv1000_set_channel(tv1000_channel);
			break;
		case '&':
			tv1000_channel = 7;
			tv1000_set_channel(tv1000_channel);
			break;
		case '*':
			tv1000_channel = 8;
			tv1000_set_channel(tv1000_channel);
			break;
		case '(':
			tv1000_channel =9;
			tv1000_set_channel(tv1000_channel);
			break;
		case ')':
			tv1000_channel = 10;
			tv1000_set_channel(tv1000_channel);
			break;
		case 'r':
			tv1000_fine_tune = 0;
			tv1000_set_fine_tune(tv1000_fine_tune);
			break;
		case 'x':
			if(tv1000_fine_tune > -1000) tv1000_fine_tune--;
			tv1000_set_fine_tune(tv1000_fine_tune);
			break;
		case 'X':
			if(tv1000_fine_tune < 1000) tv1000_fine_tune++;
			tv1000_set_fine_tune(tv1000_fine_tune);
			break;
		case 'y':
			tv1000_external_direct = 0;
			break;
		case 'Y':
			tv1000_external_direct = 1;
			break;	
		case 'z':
			tv1000_set_reg(0);
			break;
		case 'Z':
			tv1000_set_reg(1);	
			break;
		}/* end switch key value */
	fprintf(stdout, "\n");
	if(c == 27) break;/* ESCAPE */
	if(c == 'q') break;
	}/* end while key input */

exit(1);
}/* end main */
